#include <avr/io.h>

uint8_t source[10] = {10,11,12,13,14,15,16,17,18,19};
uint8_t dest[15];

int main(void) {
	
	// konfiguracja kontrolera DMA
	DMA.CTRL			=	DMA_ENABLE_bm|					// wczenie kontrolera
							DMA_DBUFMODE_DISABLED_gc|		// bez podwjnego buforowania
							DMA_PRIMODE_RR0123_gc;			// wszystkie konay rwny priorytet
	
	// konfiguracja kanau DMA
	DMA.CH0.SRCADDR0	=	(uint16_t)source & 0xFF;		// adres rda
	DMA.CH0.SRCADDR1	=	(uint16_t)source >> 8;
	DMA.CH0.SRCADDR2	=	0;
	
	DMA.CH0.DESTADDR0	=	(uint16_t)&dest[12] & 0xFF;	// adres celu
	DMA.CH0.DESTADDR1	=	(uint16_t)&dest[12] >> 8;
	DMA.CH0.DESTADDR2	=	0;
	
	DMA.CH0.TRFCNT		=	sizeof(source);					// rozmiar tablicy
	DMA.CH0.ADDRCTRL	=	DMA_CH_SRCRELOAD_NONE_gc|		// przeadowanie adresu rda po zakoczeniu bloku
							DMA_CH_SRCDIR_INC_gc|			// zwikszanie adresu rda po kadym bajcie
							DMA_CH_DESTRELOAD_NONE_gc|		// przeadowanie adresu celu po zakoczeniu bloku
							DMA_CH_DESTDIR_DEC_gc;			// zmniejszenie adresu celu po kadym bajcie
	DMA.CH0.CTRLA		=	DMA_CH_ENABLE_bm|				// wczenie kanau
							DMA_CH_TRFREQ_bm|				// uruchomienie transmisji
							DMA_CH_BURSTLEN_1BYTE_gc;		// burst = 1 bajt
	
	// pusta ptla gwna
	while(1) {}
}